<template>
  <div>
    <div v-if="serie && serie.totalAlbums" class="container">
      <SerieBanner
        :serie="serie"
        :is-subscription="isSubscription"
        :connected="connected"
      />
      <SerieResume
        class="resume"
        :serie="serie"
        :is-subscription="isSubscription"
      />
      <SerieTab
        :serie="serie"
        :connected="connected"
        :subscribed="userSubscribed"
        :initial-filter="tabCurrentFilter"
        :initial-tab="tabCurrentVolumeType"
        :initial-page="tabCurrentPage"
      />
    </div>
    <Loader :display="isLoading" />
  </div>
</template>

<script>
import SerieBanner from '~/components/Serie/SerieBanner'
import SerieResume from '~/components/Serie/SerieResume'
import SerieTab from '~/components/Serie/SerieTab'
import Loader from '~/components/ui/Loader'

export default {
  components: {
    SerieBanner,
    SerieResume,
    SerieTab,
    Loader
  },
  async fetch() {
    const redirectUrl = this.setParamsFromUrl()
    if (redirectUrl) {
      this.$nuxt.context.redirect(redirectUrl)
      return
    }
    await this.loadSerie()
  },
  data() {
    return {
      serie: undefined,
      isSubscription: false,
      connected: false,
      isLoading: true,
      tabCurrentVolumeType: undefined,
      tabCurrentFilter: undefined,
      tabCurrentPage: undefined
    }
  },
  computed: {
    isAuthenticated() {
      return this.$auth.loggedIn
    },
    ui() {
      return this.$auth.loggedIn && this.$auth.user ? this.$auth.user : {}
    },
    userSubscribed() {
      return 'hasActiveClassicSubscription' in this.ui
        ? this.ui.hasActiveClassicSubscription
        : false
    }
  },
  watch: {
    isAuthenticated(newValue) {
      //this.loadSerie()
      this.connected = newValue
      this.updateGtmData()
    }
  },
  async mounted() {
    this.$root.$on('refreshSerie', () => {
      this.loadSerie()
    })
    this.connected = this.$auth.loggedIn
    this.isSubscription = this.$utils.aboArea()

    // refresh series data for connected users (server data is prepared for guests only)
    // or reload if there is no data from SSR
    if (!this.serie || !this.serie.totalAlbums || this.connected) {
      await this.loadSerie()
    }
    this.updateGtmData()
  },
  methods: {
    async loadSerie() {
      try {
        const id = this.$api.extractIdFromSlugId(this.$route.params.slug).id
        const data = await this.$api.serie(id)

        // a serie may be unavailable for non-connected users (incl. SSR case),
        // but it may be ok for connected users.
        // if it's not available on SSR - give a chance to CSR
        if ((!data || !data.totalAlbums) && process.client) {
          console.log(`Unable to load series data (series: ${id})`)
          this.$nuxt.error({
            statusCode: 404,
            message: 'The series does not exist'
          })
        }

        this.serie = data
      } finally {
        this.isLoading = false
      }
    },

    updateGtmData() {
      if (process.client) {
        this.$utils.gtmUpdateDataLayer()
        this.$utils.gtmPush({
          pageType: 'Series'
        })

        if (this.serie) {
          this.$utils.gtmPush({
            pageRayons: this.serie.shelf.name ?? '-',
            pageGenre: this.serie.genre.name ?? '-',
            pagePublic: this.serie.target.name,
            pageEditeurs: this.serie.publishers.map((v) => v.name).join(', ')
          })

          this.$utils.gtmPush({
            event: 'detailproductView',
            EventCategory: 'ecommerce',
            EventAction: 'product detail',
            ecommerce: {
              detail: {
                actionField: { list: '' },
                products: [
                  {
                    name: this.serie.name,
                    id: this.serie.id,
                    price: '',
                    brand: this.serie.shelf.name,
                    category: 'Series',
                    dimension1: this.serie.target.name,
                    dimension2: '',
                    variant: this.serie.publishers.map((v) => v.name).join(', ')
                  }
                ]
              }
            }
          })
        }
      }
    },

    setParamsFromUrl() {
      let urlType = this.$route.params.type,
        urlSort = this.$route.params.sort,
        urlPage = this.$route.params.page

      const withParams = urlType !== undefined

      try {
        if (urlType) {
          urlType = urlType.toString().toLowerCase()
          if (
            ['chapters', 'volumes', 'others', 'subscription', 'to-buy'].indexOf(
              urlType
            ) < 0
          ) {
            throw 'wrong param urlType'
          }
        }

        if (urlSort) {
          urlSort = urlSort.toString().toLowerCase()
          if (['new', 'old', 'price', 'rating'].indexOf(urlSort) < 0) {
            throw 'wrong param urlSort'
          }
        }

        if (urlPage) {
          urlPage = +urlPage
          if (isNaN(urlPage)) {
            throw 'wrong param urlPage'
          }
        } else {
          urlPage = 1
        }
      } catch (e) {
        urlType = urlSort = urlPage = undefined
      }

      if (withParams && !urlType) {
        return this.localePath({
          name: 'shelf-genre-slug',
          params: {
            shelf: this.$route.params.shelf,
            genre: this.$route.params.genre,
            slug: this.$route.params.slug
          }
        })
      }
      this.tabCurrentVolumeType = urlType
      this.tabCurrentFilter = urlSort
      this.tabCurrentPage = urlPage
      return null
    }
  },
  head() {
    return {
      title: this.serie ? this.serie.name : '',
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: this.serie
            ? this.$t('meta.pageSerie', {
                NOMDELASERIE: this.serie.name,
                NOMDURAYON: this.$utils.prepareMetaDescription(
                  this.serie.genre.name ?? ''
                )
              })
            : ''
        },
        // facebook METAs
        {
          hid: 'og:title',
          name: 'og:title',
          content: this.serie ? this.serie.name : ''
        },
        {
          hid: 'og:description',
          name: 'og:description',
          content:
            this.serie && this.serie.synopsis
              ? this.serie.synopsis.slice(0, 400)
              : ''
        },
        {
          hid: 'og:image',
          name: 'og:image',
          content: this.serie
            ? this.serie.shelf.id === 6
              ? `${this.$config.izneoUrl}/${this.$i18n.locale}/images/serie/${this.serie.id}-w360.jpg`
              : `${this.$config.izneoUrl}/${this.$i18n.locale}/images/serie/${this.serie.cover}-w360.jpg`
            : ''
        },
        {
          hid: 'og:image:width',
          name: 'og:image:width',
          content: this.serie ? 360 : 0
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
.container {
  .resume {
    display: block;
  }

  // please uncomment in case of trouble (quick fix)
  @media (max-width: 1259px) {
    padding-top: 85px;
  }

  @media (max-width: 1024px) {
    padding-top: 70px;
  }

  @media (max-width: 768px) {
    .resume {
      display: none;
    }
  }
}
</style>
